/** 
 * @file Audio.h
 * @brief ĐNXwb_t@C
 * @note ĐɊւ鏈s<br>
 * @date 2008/04/21
 */
#ifndef _AUDIO_H_
#define _AUDIO_H_

class Cogg_loader;

namespace AquaGameSystem {

	//======================================
	// class CAudioAbstract
	//======================================
	/** @brief ĐNX(ۃNX)
	 * @note GNX|[gpۃNX<br>
	 */
	class CAudioAbstract
	{
	public:
		virtual int		Init(HINSTANCE hInstance, HWND hWnd, int ch_size) = 0;
		virtual void	Term() = 0;
		virtual int		play(int ch, LPCSTR lpszFileName, BOOL bLoop) = 0;
		virtual int		replay(int ch) = 0;
		virtual void	stop(int ch) = 0;
	};

	//======================================
	// class CAudio
	//======================================
	/** @brief ĐNX
	 * @note ĐNXɊւ鏈s<br>
	 */
	class CAudio : public CAudioAbstract
	{
	private:
		static CAudio*			st_Instance;			/// CX^X
		Cogg_loader*			m_ogg_loader;			/// oggǂݍ݃NX
		int						m_ch_size;				/// `l̍ő吔

	public:
		/// ftHgRXgN^
		CAudio();
		///@fXgN^
		virtual ~CAudio();
		/// CX^X̎擾
		static CAudio*				GetInstance(void);

		/// 
		virtual int		Init(HINSTANCE hInstance, HWND hWnd, int ch_size);
		/// I
		virtual void	Term();
		/// ĐJn
		virtual int		play(int ch, LPCSTR lpszFileName, BOOL bLoop);
		/// JԂĐJn
		virtual int		replay(int ch);
		/// Đ~
		virtual void	stop(int ch);
	};


}

#endif // _AUDIO_H_

