/** 
 * @file AquaGameSystem.h
 * @brief AquaGameSystemIuWFNgǗwb_t@C
 * @note AquaGameSystemIuWFNgǗs<br>
 * @date 2008/04/21
 */
#ifndef _AQUA_GAME_SYSTEM_H_
#define _AQUA_GAME_SYSTEM_H_

#ifndef _AQUA_GAME_SYSTEM_MAKE
	#pragma comment (lib, "winmm.lib")
	#pragma comment (lib, "dxguid.lib")
	#pragma comment (lib, "d3d9.lib")
	#pragma comment (lib, "d3dx9.lib")
	#pragma comment (lib, "dinput8.lib")
	#pragma comment (lib, "ogg_static.lib")
	#pragma comment (lib, "vorbis_static.lib")
	#pragma comment (lib, "vorbisfile_static.lib")

	#ifdef _DLL
		#ifdef _DEBUG
			#pragma comment(lib, "./AquaGameSystemMDd.lib")
		#else // _DEBUG
			#pragma comment(lib, "./AquaGameSystemMD.lib")
		#endif // _DEBUG
	#else // _DLL
		#ifdef _DEBUG
			#pragma comment(lib, "./AquaGameSystemMTd.lib")
		#else // _DEBUG
			#pragma comment(lib, "./AquaGameSystemMT.lib")
		#endif // _DEBUG
	#endif // _DLL
#endif // _AQUA_GAME_SYSTEM_MAKE

#include "Graphics.h"
#include "Input.h"
#include "Audio.h"

using namespace AquaGameSystem;
typedef CGraphics*			(*ty_AquaGameSystemGraphicsCreate)();
typedef CInput*				(*ty_AquaGameSystemInputCreate)();
typedef CAudio*				(*ty_AquaGameSystemAudioCreate)();


#endif // _AQUA_GAME_SYSTEM_H_
