#ifndef _TYPEDEF_H_
#define _TYPEDEF_H_

// `
struct RECT_FLOAT {
	FLOAT	left;
	FLOAT	top;
	FLOAT	right;
	FLOAT	bottom;
};

struct RECT_DOUBLE {
	DOUBLE	left;
	DOUBLE	top;
	DOUBLE	right;
	DOUBLE	bottom;
};

struct RECT_ULONG {
	ULONG	left;
	ULONG	top;
	ULONG	right;
	ULONG	bottom;
};

// W
struct POINT_FLOAT {
	FLOAT	x;
	FLOAT	y;
	FLOAT	z;
};

struct POINT_DOUBLE {
	DOUBLE	x;
	DOUBLE	y;
	DOUBLE	z;
};

struct POINT_ULONG {
	ULONG	x;
	ULONG	y;
	ULONG	z;
};

// 2DW
struct VECTOR2_FLOAT {
	FLOAT	x;
	FLOAT	y;
	VECTOR2_FLOAT(void)
	{
		x = 0.0f;
		y = 0.0f;
	}
	VECTOR2_FLOAT(FLOAT init_x, FLOAT init_y)
	{
		x = init_x;
		y = init_y;
	}
};

struct VECTOR2_DOUBLE {
	DOUBLE	x;
	DOUBLE	y;
	VECTOR2_DOUBLE(void)
	{
		x = 0.0f;
		y = 0.0f;
	}
	VECTOR2_DOUBLE(DOUBLE init_x, DOUBLE init_y)
	{
		x = init_x;
		y = init_y;
	}
};

struct VECTOR2_ULONG {
	ULONG	x;
	ULONG	y;
	VECTOR2_ULONG(void)
	{
		x = 0;
		y = 0;
	}
	VECTOR2_ULONG(ULONG init_x, ULONG init_y)
	{
		x = init_x;
		y = init_y;
	}
};


#define 	DIRECTION4_NONE			0x0000
#define 	DIRECTION4_UP			0x0001
#define 	DIRECTION4_DOWN			0x0002
#define 	DIRECTION4_LEFT			0x0004
#define 	DIRECTION4_RIGHT		0x0008

#endif // _TYPEDEF_H_
